C     MOLECULAR PLANES ......13TH NOV. 1968.....D.J.HUNT...YORK
      PROGRAM LSQPL
	COMMON/UN/A,B,C,ALPHA,BETA,GAMMA,NA
      DIMENSION X(50),Y(50),Z(50),XO(50),YO(50),ZO(50),N(20),NR(20)             
      DIMENSION O(3,3),P(3,3),E(3),DEO(3,3),SM(3,3),DP(3,3)                    
      DIMENSION PL(30),PM(30),PN(30)                
      CHARACTER*4 ATOM(50),ATP(50),ATO(50)
C                                                   
      LT=6                                          
	IP=1
	CALL READ(ATOM,X,Y,Z)
C                               
C    SET UP ORTHOGONOLIZING MATRIX
C                               
  225 WRITE(LT,27)              
   27 FORMAT( /29X,'ATOMIC COORDINATES'//29X,'REAL',36X,'ORTHOGONAL'/)          
      F=0.0174533               
      ALPHA=ALPHA*F             
      BETA=BETA*F               
      GAMMA=GAMMA*F             
      COSW=(COS(BETA)-COS(ALPHA)*COS(GAMMA))/(SIN(ALPHA)*SIN(GAMMA))           
      SINW=SQRT(1.-COSW*COSW)   
      O(1,1)=A*SIN(GAMMA)*SINW  
      O(1,2)=0.                 
      O(1,3)=0.                 
      O(2,1)=A*COS(GAMMA)       
      O(2,2)=B                  
      O(2,3)=C*COS(ALPHA)       
      O(3,1)=A*SIN(GAMMA)*COSW  
      O(3,2)=0.                 
      O(3,3)=C*SIN(ALPHA)       
C    ORTHOGONOLISE AND PRINT    
C                               
      DO 5 I=1,NA               
      XO(I)=O(1,1)*X(I)         
      YO(I)=O(2,1)*X(I)+O(2,2)*Y(I)+O(2,3)*Z(I)                                  
      ZO(I)=O(3,1)*X(I)+O(3,3)*Z(I)                                                 
   5  CONTINUE                  
      WRITE(LT,28)(I,ATOM(I),X(I),Y(I),Z(I),XO(I),YO(I),ZO(I),I=1,NA)              
   28 FORMAT(10X,I5,3X,A4,3X,3F10.5,10X,3F10.5)                                 
C                               
C     READ PLANE-DESIGNATOR NUMBERS
C                               
      II=0  
   21 READ(5,7)(N(I),I=1,18),(NR(I),I=1,18)                                        
    7 FORMAT(36I2)                                                                    
      IF(N(1)) 24,24,25                                                         
C    A BLANK CARD INDICATES STOP                                                
C       THE FIRST 36 COLS ARE FOR PLANE ATOMS, THE REST FOR ATOMS               
C      TO BE REPOSITIONED ONLY                                                  
C           
C      FIND CENTROID                                                            
C
   25 L=0   
      II=II+1                                                                         
      DO 300 I=1,18                                                                   
      IF(N(I)) 305,305,310                                                        
  310 K=N(I)                                                                          
      L=L+1 
      ATP(L)=ATOM(K)                                                              
  300 CONTINUE                                                                    
  305 WRITE(LT,307) II,(ATP(I),I=1,L)                                             
  307 FORMAT(//5X,'THE MEAN PLANE (',I2,')   THROUGH THE ATOMS'//                    
     1  10X,18(A4,3X))                                                                
      XSUM=0.                                                                         
      YSUM=0.                                                                         
      ZSUM=0.                                                                         
      DO 8 I=1,18                                                                     
      IF(N(I)) 9,9,10                                                              
   10 M=N(I)                                                                          
      XSUM=XSUM+XO(M)                                                                 
      YSUM=YSUM+YO(M)                                                                 
      ZSUM=ZSUM+ZO(M)                                                               
    8 CONTINUE                                                                      
    9 NC=I-1
      XC=XSUM/NC                                                                      
      YC=YSUM/NC                                                                      
      ZC=ZSUM/NC                                                                
C           
C   REPOSITION ATOMS WRT TO CENTROID                                            
C           
      DO 12 I=1,3                                                               
      DO 13 J=1,3                                                       
      SM(I,J)=0.                                                        
   13 CONTINUE                                                          
   12 CONTINUE                                                          
      DO 11 I=1,NC                                                      
      M=N(I)                                                            
      X(M)=XO(M)-XC                                                     
      Y(M)=YO(M)-YC                                                     
      Z(M)=ZO(M)-ZC                                                     
C                                                                       
C   THE ORIGINAL POSITION ARRAYS (X,Y,Z) ARE THUS DESTROYED             
C                                                                       
C    SET UP SECOND MOMENTS MATRIX(SM)                                   
C                                                                       
      SM(1,1)=X(M)*X(M)+SM(1,1)                                         
      SM(1,2)=X(M)*Y(M)+SM(1,2)                                         
      SM(1,3)=X(M)*Z(M)+SM(1,3)                                         
      SM(2,2)=Y(M)*Y(M)+SM(2,2)                                         
      SM(2,3)=Y(M)*Z(M)+SM(2,3)                                         
      SM(3,3)=Z(M)*Z(M)+SM(3,3)                                         
   11 CONTINUE                                                          
      SM(2,1)=SM(1,2)                                                   
      SM(3,1)=SM(1,3)                                                   
      SM(3,2)=SM(2,3)                                                   
      TOL=0.0000005                                                     
      CALL ROTATE (3,SM,P,E,3,TOL)                                      
C                                                                       
C     DEORTHOGONOLIZE AND PRINT  DIRECTION COSINES AND LATENT ROOTS     
C                                                                       
      WRITE (LT,281)                                                    
  281 FORMAT(/ 5X,'DIRECTION COSINES OF THE PLANE'/15X,'REAL SPACE',29X,
     1 'ORTHOGONAL SPACE'/)                                             
      DEO(1,1)=SIN(GAMMA)*SINW                                          
      DEO(1,2)=COS(GAMMA)                                               
      DEO(1,3)=SIN(GAMMA)*COSW                                          
      DEO(3,2)=COS(ALPHA)                                               
      DEO(3,3)=SIN(ALPHA)                                               
      DP(1,1)=P(1,1)*DEO(1,1)+P(1,2)*DEO(1,2)+P(1,3)*DEO(1,3)           
      DP(2,1)=P(2,1)*DEO(1,1)+P(2,2)*DEO(1,2)+P(2,3)*DEO(1,3)           
      DP(3,1)=P(3,1)*DEO(1,1)+P(3,2)*DEO(1,2)+P(3,3)*DEO(1,3)                         
      DP(1,2)=P(1,2)                                
      DP(2,2)=P(2,2)                                
      DP(3,2)=P(3,2)                                
      DP(1,3)=P(1,2)*DEO(3,2)+P(1,3)*DEO(3,3)       
      DP(2,3)=P(2,2)*DEO(3,2)+P(2,3)*DEO(3,3)       
      DP(3,3)=P(3,2)*DEO(3,2)+P(3,3)*DEO(3,3)       
      WRITE(LT,16)(DP(1,J),J=1,3),(P(1,J),J=1,3)    
   16 FORMAT(5X,3F10.5,10X,3F10.5/)                 
      PL(II)=P(1,1)                                 
      PM(II)=P(1,2)                                 
      PN(II)=P(1,3)                                 
      WRITE(LT,19)E(1),E(2),E(3)                    
   19 FORMAT(1H0,5X,15H LATENT ROOTS  ,3F10.5)      
C                                                   
C     ORIGIN TO PLANE DISTANCE....DEVIATIONS ARE  +VE IF ATOM ON                
C     OPPOSITE SIDE OF PLANE TO ORIGIN.             
C                                                   
      OP=XC*P(1,1)+YC*P(1,2)+ZC*P(1,3)              
      WRITE(LT,30)OP                                
   30 FORMAT(1H0,4X,28H ORIGIN TO PLANE DISTANCE = ,F10.4,12H   ANGSTROM             
     1S)                                            
C     OP=ABS(OP)                                    
C                                                   
C     REPOSITION THE ATOMS WRT THIS PLANE  / WRT = WITH RESPECT TO
C                                                   
      WRITE(LT,29)                                  
   29 FORMAT(/5X,'ATOM',5X,'DEVIATION FROM THE PLANE IN ANGSTROMS'/)                  
      DO 14 I=1,NC                                  
      M=N(I)                                        
      X(M)=XO(M)*P(1,1)+YO(M)*P(1,2)+ZO(M)*P(1,3)   
      Y(M)=XO(M)*P(2,1)+YO(M)*P(2,2)+ZO(M)*P(2,3)   
      Z(M)=XO(M)*P(3,1)+YO(M)*P(3,2)+ZO(M)*P(3,3)   
C     DEVN=ABS(X(M))-OP                             
      DEVN=X(M)-OP
      IF(OP) 601,602,602
  601 DEVN=-DEVN
  602 WRITE(LT,15) M,ATP(I),DEVN                    
   15 FORMAT(5X,I2 ,A4,12X,F10.5)                   
   14 CONTINUE                                      
C                                                   
C     REPOSITION EXTRA ATOMS WRT THIS PLANE         
C
      WRITE(LT,26)              
   26 FORMAT(/5X,'ATOM TO PLANE DISTANCES IN ANGSTROMS'/)                             
      L=0                       
      DO 330 I=1,18             
      IF(NR(I)) 340,340,350     
  350 K=NR(I)                   
      L=L+1                     
      ATO(L)=ATOM(K)            
  330 CONTINUE                  
  340 DO 20 I=1,18              
      IF(NR(I)) 21,21,22        
   22 M=NR(I)                   
      X(M)=XO(M)*P(1,1)+YO(M)*P(1,2)+ZO(M)*P(1,3)                                     
      Y(M)=XO(M)*P(2,1)+YO(M)*P(2,2)+ZO(M)*P(2,3)                                     
      Z(M)=XO(M)*P(3,1)+YO(M)*P(3,2)+ZO(M)*P(3,3)                                     
C     DEVN=ABS(X(M))-OP         
      DEVN=X(M)-OP
      IF(OP) 701,702,702
  701 DEVN=-DEVN
  702 WRITE(LT,15) M,ATO(I),DEVN
   20 CONTINUE                  
   24 IF(IP) 500,500,510        
  510 WRITE(LT,450)             
  450 FORMAT(///5X,'THE ANGLES BETWEEN PLANES'//)                                     
      III=II-1                  
      DO 460 I=1,III            
      K=I+1                     
      DO 465 J=K,II             
      CANGLE =PL(I)*PL(J)+PM(I)*PM(J)+PN(I)*PN(J)                                     
      SANGLE=SQRT(1.0-CANGLE**2)                                                      
      ANGLE=ATAN2(SANGLE,CANGLE)*57.29578                                             
      IF(ANGLE-90.0) 480,480,470
  470 ANGLE=180.0-ANGLE         
  480 WRITE(LT,490) I,J,ANGLE   
  490 FORMAT(/5X,'PLANE (',I2,')     PLANE (',I2,')',5X,F8.2,3X,'DEGREES             
     1  ')                      
  465 CONTINUE                  
  460 CONTINUE                  
  500 STOP                      
      END  
C
C                     
      SUBROUTINE ROTATE(NDIM,A,V,E,N,TOL)                                       
      DIMENSION A(NDIM,NDIM),V(NDIM,NDIM),E(NDIM)                              
      DO 601 I=1,N                                                             
      DO 600 J=1,N                                                             
  600 V(I,J)=0.                                                               
  601 V(I,I)=1.                                                                
  602 D2=0. 
      D1=0. 
      DO 603 I=1,N                                                              
      AII=ABS(A(I,I))                                                           
      IF(AII.GT.D1)D1=AII                                                      
  603 CONTINUE                                                                
      D1=TOL*D1                                                               
      N1=N-1
      DO 604 I=1,N1                                                             
      I1=I+1
      DO 604 J=I1,N                                                             
      AIJ=ABS(A(I,J))                                                           
      IF(AIJ.GT.D2)D2=AIJ                                                     
  604 CONTINUE                                                                 
      IF(D2.LE.D1) GO TO 614                                                   
      D2=0.2*D2                                                                 
      IZ=0  
      DO 613 I=1,N1                                                             
      I1=I+1
      DO 613 J=I1,N                                                             
      AIJ=A(I,J)                                                               
      IF(AIJ)606,613,605                                                     
  605 IF(AIJ-D2)613,613,607                                                  
  606 IF(AIJ+D2)607,613,613                                                  
  607 IZ=1+IZ                                                               
      AD=A(I,I)-A(J,J)                                                      
      T=1.0 
      IF(AD.EQ.0.0)GO TO 610                                                   
      T=AIJ/AD                                                                 
      IF(T)609,610,608                                                      
  608 IF(T.GT.1.)T=+1.                                                       
  609 IF(T.LT.(-1.))T=-1.                                                     
  610 G=T/(2.0*(1.0+T**2))                                                     
      SN=(2.0*G)/(1.0+G**2)                                                     
      CN=1.0-G*SN                                                       
      DO 611 K=1,N                                                      
      AIK=A(I,K)                                                        
      A(I,K)=CN*AIK+SN*A(J,K)                                           
      A(J,K)=CN*A(J,K)-SN*AIK                                           
      VIK=V(I,K)                                                        
      V(I,K)=CN*VIK+SN*V(J,K)                                           
  611 V(J,K)=CN*V(J,K)-SN*VIK                                           
      DO 612 K=1,N                                                      
      AKI=A(K,I)                                                        
      A(K,I)=CN*AKI+SN*A(K,J)                                           
  612 A(K,J)=CN*A(K,J)-SN*AKI                                           
  613 CONTINUE                                                          
      IF(IZ.NE.0)GO TO 602                                              
  614 DO 615 I=1,N                                                      
  615 E(I)=A(I,I)                                                       
      DO 617 I=1,N1                                                     
      KK=0                                                              
      EM=E(I)                                                           
      NN=I+1                                                            
      DO 616 J=NN,N                                                     
      IF(E(J).GE.EM) GO TO 616                                          
      EM=E(J)                                                           
      KK=J                                                              
  616 CONTINUE                                                          
      IF(KK.LE.0) GO TO 617                                             
      E(KK)=E(I)                                                        
      E(I)=EM                                                           
      DO 619 K=1,N                                                      
      VT=V(I,K)                                                         
      V(I,K)=V(KK,K)                                                    
      V(KK,K)=VT                                                        
  619 CONTINUE                                                          
  617 CONTINUE                                                          
      RETURN                 
	END                                           
C
C	LECTURE DU FICHIER 'user'.PAR CREE PAR SHELX
C
	SUBROUTINE READ(ATOM,X,Y,Z)
	COMMON/UN/A,B,C,ALPHA,BETA,GAMMA,NA
	DIMENSION X(50),Y(50),Z(50)
      CHARACTER*4 ATOM(50),BUF*80
      DIMENSION FMT(10),UIJ(3,3),AT(3),S(3,3)
C	CARTES 'TITL' ET 'CELL'----------------
        READ(5,'(4X,10A4)')FMT
	WRITE(6,'(4X,10A4)') FMT     
        READ(5,'(13X,6F9.4)') A,B,C,ALPHA,BETA,GAMMA
        WRITE(6,116) A,B,C,ALPHA,BETA,GAMMA          
  116 FORMAT(5X,'CELL DIMENSIONS'/15X,' A = ',F10.3 ,2X,'ANGSTROMS'/            
     1 15X,' B = ',F10.3/15X,' C = ',F10.3/         
     2 12X,'ALPHA = ',F10.3,2X,'DEGREES'/12X,' BETA = ',F10.3/                  
     3 12X,'GAMMA = ',F10.3/)
    2 READ(5, '(A)',END=5,ERR=5) BUF
      IF (BUF(1:4).EQ.'    ') GOTO 2
      IF (BUF(1:4).EQ.'AFIX') GOTO 2
      IF (BUF(1:4).EQ.'WGHT') GOTO 2
      IF (BUF(1:4).EQ.'FVAR') GOTO 2
      IF (BUF(1:3).EQ.'END') GOTO 5
C	CARTES 'ATOM'--------------------
	NA=NA+1
      READ (BUF,12) ATOM(NA),AT(1),AT(2),AT(3),UIJ(1,1),UIJ(2,2)
   12 FORMAT(A4,7X,3(F8.2,2X),10X,2(F8.2,2X))
      IF (UIJ(2,2).GT.0.00001) THEN
      READ (5,13) UIJ(3,3),UIJ(2,3),UIJ(1,3),UIJ(1,2)
   13 FORMAT(7X,4(F8.2,2X))
      ENDIF
	DO 202 I=1,3
	IF(AT(I).GT.5.)	AT(I)=AT(I)-10.
  202   CONTINUE
	X(NA)=AT(1)
	Y(NA)=AT(2)
	Z(NA)=AT(3)
      READ (5,14) SX,SY,SZ,S(1,1),S(2,2),S(3,3),S(2,3),S(1,3),S(1,2)
   14 FORMAT(4X,9F8.5)
	GOTO 2
    5 WRITE(6,180) NA                              
  180 FORMAT(5X,'NUMBER OF ATOMS TO BE INPUT IS ',I8/)                          
    	RETURN
      END                                                               
